#ifndef Math_Point3D_h
#define Math_Point3D_h

/* no root, if it's not possible
#include <Rtypes.h>
#include <Math/Cartesian3D.h>
#include <Math/Point3D.h>
*/

#include "DataFormats/GeometryVector/interface/GlobalPoint.h"
#include "FWCore/MessageLogger/interface/MessageLogger.h"
#include <ostream>                                                                                              

namespace math {
  class XYZPoint 
  {
    public:
    XYZPoint();
    XYZPoint ( const GlobalPoint & o );
    XYZPoint ( double x, double y, double z );
    void SetX ( double );
    void SetY ( double );
    void SetZ ( double );
    double X() const;
    double Y() const;
    double Z() const;
    double x() const;
    double y() const;
    double z() const;

    double perp2() const;
    private:
      double x_;
      double y_;
      double z_;
  };
}

edm::LogBase & operator<< ( edm::LogBase &, const math::XYZPoint & );
std::ostream & operator<< ( std::ostream &, const math::XYZPoint & ); 

#endif
