//
// C++ Interface: TransientTrackKinematicParticle
//
// Description:
//
//
// Author: Fabian Moser <fabiamos@gmail.com>, (C) 2007
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef RAVETRANSIENTTRACKKINEMATICPARTICLE_H
#define RAVETRANSIENTTRACKKINEMATICPARTICLE_H

#include <rave/KinematicParticle.h>
#include <rave/BasicTransientTrackKinematicParticle.h>

namespace rave
{

/**
 @author Fabian Moser <fabiamos@gmail.com>
*/
class TransientTrackKinematicParticle :
      public KinematicParticle
{
  public:
    TransientTrackKinematicParticle (
      const rave::Track & initialTrack, const double & massGuess,
      const double & massSigma, const double & chiSquared,
      const double & degreesOfFr, boost::any origin = boost::any(),
      std::string tag = "" );

    TransientTrackKinematicParticle (
      const rave::Track & initialTrack, const double & massGuess,
      const double & massSigma, boost::any origin = boost::any(),
      std::string tag = "" );

    TransientTrackKinematicParticle ( const rave::BasicTransientTrackKinematicParticle & );
    TransientTrackKinematicParticle();

};

}

#endif
