#include "RaveBase/RaveInterface/rave/CalibrationHistogram.h"
#include <iostream>

using namespace rave;
using namespace std;

CalibrationHistogram::CalibrationHistogram() {}

CalibrationHistogram::CalibrationHistogram( int taggingvar, float jetptmin, float jetptmax,
    float jetetamin, float jetetamax, int vtxtype, int partontype ) : 
  theTaggingVariable ( taggingvar ), theJetPtMin ( jetptmin ), theJetPtMax ( jetptmax ),
  theJetEtaMin ( jetetamin ), theJetEtaMax ( jetetamax ), theVertexType ( vtxtype ),
  thePartonType ( partontype )
{}

CalibrationHistogram::CalibrationHistogram( int taggingvar, float jetptmin, float jetptmax,
    float jetetamin, float jetetamax, int vtxtype, int partontype,
    const std::map < float, float > & histo, int entries ) :
  Histogram ( histo, entries ),
  theTaggingVariable ( taggingvar ), theJetPtMin ( jetptmin ), theJetPtMax ( jetptmax ),
  theJetEtaMin ( jetetamin ), theJetEtaMax ( jetetamax ), theVertexType ( vtxtype ),
  thePartonType ( partontype )
{}

float CalibrationHistogram::jetPtMin() const
{
  return theJetPtMin;
}

float CalibrationHistogram::jetPtMax() const
{
  return theJetPtMax;
}

float CalibrationHistogram::jetEtaMin() const
{
  return theJetEtaMin;
}

float CalibrationHistogram::jetEtaMax() const
{
  return theJetEtaMax;
}

int CalibrationHistogram::vertexType() const
{
  return theVertexType;
}

int CalibrationHistogram::partonType() const
{
  return thePartonType;
}

int CalibrationHistogram::taggingVariable() const
{
  return theTaggingVariable;
}

void CalibrationHistogram::dump() const
{
  cout << "CalibrationHistogram: tagvar=" << theTaggingVariable
       << ", pt=[" << theJetPtMin << ", " << theJetPtMax << "]"
       << ", eta=[" << theJetEtaMin << ", " << theJetEtaMax << "]"
       << ", vtx=" << theVertexType << ", parton=" << thePartonType
       << endl;
  Histogram::dump();
}
