#include "RaveBase/RaveInterface/rave/CalibrationRun.h"

using namespace std;
using namespace rave;

CalibrationRun::CalibrationRun ( const std::string & date, int n_events, 
    const std::string & vtx_rector, const std::string & version,
    const std::string & sample, const std::string & rave  ) : date_(date), nevents_(n_events),
       vtxrector_(vtx_rector), externalVer_ ( version ),
       sample_ ( sample ), raveVer_ ( rave )
{}

const string & CalibrationRun::date() const
{
  return date_;
}

const int CalibrationRun::nevents() const
{
  return nevents_;
}

const std::string & CalibrationRun::vertexReconstructor() const
{
  return vtxrector_;
}

const std::string & CalibrationRun::externalVersion() const
{
  return externalVer_;
}

const std::string & CalibrationRun::raveVersion() const
{
  return raveVer_;
}

const std::string & CalibrationRun::sample() const
{
  return sample_;
}


