#include "rave/KinematicParticle.h"

namespace rave
{

KinematicParticle::KinematicParticle( const BasicKinematicParticle & o ) :
    Base( o.clone() )
{}

KinematicParticle::KinematicParticle() :
    Base ( new BasicKinematicParticle () )
{}

const rave::Vector7D & KinematicParticle::fullstate() const
{
  return data().fullstate();
}

const rave::Covariance7D & KinematicParticle::fullerror() const
{
  return data().fullerror();
}

const rave::Vector6D & KinematicParticle::state() const
{
  return data().state();
}

const rave::Covariance6D & KinematicParticle::error() const
{
  return data().error();
}

Charge KinematicParticle::charge() const
{
  return data().charge();
}

double KinematicParticle::chi2() const
{
  return data().chi2();
}

double KinematicParticle::ndof() const
{
  return data().ndof();
}

boost::shared_ptr< rave::MagneticField > KinematicParticle::magneticField() const
{
  return data().magneticField();
}

boost::shared_ptr< rave::KinematicConstraint > KinematicParticle::lastConstraint() const
{
  return data().lastConstraint();
}

int KinematicParticle::id() const
{
  return data().id();
}

boost::any rave::KinematicParticle::link() const
{
  return data().link();
}

std::string rave::KinematicParticle::tag() const
{
  return data().tag();
}

bool rave::KinematicParticle::isValid() const
{
  return data().isValid();
}

bool rave::KinematicParticle::operator<( const rave::KinematicParticle & o ) const
{
  return ( id() < o.id() );
}

}
