#include "RaveBase/RaveInterface/rave/Point3D.h"

namespace rave
{

Point3D::Point3D( double x, double y, double z ) :
  thex(x), they(y), thez(z) {}
  
Point3D::Point3D() :
  thex(0.), they(0.), thez(0.) {}

double Point3D::x() const
{
  return thex;
}

double Point3D::y() const
{
  return they;
}

double Point3D::z() const
{
  return thez;
}

double Point3D::mag2() const
{
  return thex*thex+they*they+thez*thez;
}

double Point3D::mag() const
{
  return sqrt(mag2());
}

double Point3D::perp2() const
{
  return thex*thex+they*they;
}

double Point3D::perp() const
{
  return sqrt ( perp2() );
}

bool Point3D::equal(const Point3D & other) const
{
  return ( x() == other.x() ) && ( y() == other.y() ) && ( z() == other.z() );
}

} // namespace rave

bool operator==(const rave::Point3D & lhs, const rave::Point3D & rhs)
{
  return lhs.equal(rhs);
}
