#include "RaveBase/RaveInterface/rave/TransientTrackKinematicParticle.h"

#include "RaveBase/RaveEngine/interface/TaggedTransientTrackKinematicParticle.h"

namespace rave
{

TransientTrackKinematicParticle::TransientTrackKinematicParticle (
  const rave::Track & initialTrack, const double & massGuess,
  const double & massSigma, const double & chiSquared,
  const double & degreesOfFr, boost::any origin, std::string tag ) :
    KinematicParticle ( BasicTransientTrackKinematicParticle (
                          initialTrack, massGuess, massSigma, chiSquared,
                          degreesOfFr, origin, tag ) )
{
  // OK, this is dirty, but a the clever ReferenceCountingPointer does not
  // allow anything else (as the shared_ptr would), here it is:
  static_cast< ::TaggedTransientTrackKinematicParticle* > (
    boost::any_cast< ::RefCountedKinematicParticle > (
      data().getInternal() ).get() )->setTag ( *this );
}

TransientTrackKinematicParticle::TransientTrackKinematicParticle (
  const rave::Track & initialTrack, const double & massGuess,
  const double & massSigma, boost::any origin, std::string tag ) :
    KinematicParticle ( BasicTransientTrackKinematicParticle (
                          initialTrack, massGuess, massSigma, origin, tag ) )
{
  // OK, this is dirty, but a the clever ReferenceCountingPointer does not
  // allow anything else (as the shared_ptr would), here it is:
  static_cast< ::TaggedTransientTrackKinematicParticle* > (
    boost::any_cast< ::RefCountedKinematicParticle > (
      data().getInternal() ).get() )->setTag ( *this );
}

TransientTrackKinematicParticle::TransientTrackKinematicParticle (
  const BasicTransientTrackKinematicParticle & o ) :
    KinematicParticle ( *(o.clone()) )
{}

TransientTrackKinematicParticle::TransientTrackKinematicParticle() :
    KinematicParticle ( BasicTransientTrackKinematicParticle () )
{}

}
