#include "RaveBase/RaveInterface/rave/Vector4D.h"

namespace rave
{

Vector4D::Vector4D ( double x, double y, double z, double m ) :
    Vector3D ( x, y, z ), them ( m )
{}

Vector4D::Vector4D ( rave::Vector3D v, double m ) :
    Vector3D ( v ), them ( m )
{}

Vector4D::Vector4D() :
    Vector3D(), them ( 0. )
{}

double Vector4D::m() const
{
  return them;
}

bool Vector4D::equal ( const rave::Vector4D & o ) const
{
  return Vector3D::equal ( o ) && ( m() == o.m() );
}

} // namespace rave

bool operator == ( const rave::Vector4D & lhs, const rave::Vector4D & rhs )
{
  return lhs.equal ( rhs );
}
