#ifndef _FitterFromLinPtFinder_H_
#define _FitterFromLinPtFinder_H_

#include "RecoVertex/VertexTools/interface/LinearizationPointFinder.h"
#include "RecoVertex/VertexPrimitives/interface/VertexFitter.h"

/**
 *  Wrap any LinearizationPointFinder into the VertexReconstructor interface
 */

class FitterFromLinPtFinder : public VertexFitter
{
  public:
    FitterFromLinPtFinder ( const LinearizationPointFinder & );
    FitterFromLinPtFinder ( const FitterFromLinPtFinder & o );
    ~FitterFromLinPtFinder();

    CachingVertex vertex ( const std::vector < reco::TransientTrack > & t ) const;
    CachingVertex vertex( const vector<RefCountedVertexTrack> & tracks) const;
    CachingVertex vertex( const vector<reco::TransientTrack> & tracks, 
        const GlobalPoint& linPoint) const;
    CachingVertex vertex( const vector<reco::TransientTrack> & tracks, 
        const GlobalPoint& priorPos, const GlobalError& priorError) const;
    CachingVertex vertex( const vector<reco::TransientTrack> & tracks, 
                          const reco::BeamSpot& beamSpot) const;
    CachingVertex vertex(const vector<RefCountedVertexTrack> & tracks, 
      const GlobalPoint& priorPos, const GlobalError& priorError) const;

    FitterFromLinPtFinder * clone () const;

  private:
    const LinearizationPointFinder * theLinPtFinder;
};

#endif
